package bank

import (
	"fmt"
	"log"
	"strconv"
	"strings"
	"time"
	"wartank/pkg/alias"
	"wartank/pkg/arena"
	"wartank/pkg/components/arena_net"
	"wartank/pkg/types"
	"wartank/server/serv_bots/warbot/angar/base/bank/bank_mode"
	"wartank/server/serv_bots/warbot/stat_tank/static_param"
)

/*
	Предоставляет объект банка на базе
*/

// Банк -- объект банка на базе
type Банк struct {
	types.ИАрена
	сеть       types.ИАренаСеть
	сереброБот types.ИСтатПарам
	режим1     *bank_mode.BankMode // 1 режим работы на выбор
	режим2     *bank_mode.BankMode // 2 режим работы на выбор
}

// НовБанк -- возвращает новый *Bank
func НовБанк(база types.ИБаза) (*Банк, error) {

	сам := &Банк{
		сереброБот: static_param.НовСтатПарам("silver_bot"),
		режим1:     bank_mode.NewBankMode(),
		режим2:     bank_mode.NewBankMode(),
	}
	аренаКонфиг := arena.АренаКонфиг{
		Бот_:         база.Бот(),
		АренаИмя_:    "Банк",
		СтрКонтроль_: `<span class="green2">Серебро</span><br/>`,
		ФнПуск_:      сам.пуск,
		СтрУрл_:      "https://wartank.ru/production/Bank",
	}
	сам.ИАрена = arena.НовАрена(аренаКонфиг)
	сам.сеть = arena_net.НовАренаСеть(сам, "https://wartank.ru/production/Bank")
	return сам, nil
}

// Пуск -- запускает банк в работу
func (сам *Банк) Пуск() error {
	log.Printf("Банк.Run()\n")
	go сам.пуск()
	return nil
}

// UpdateLst -- принудительно обновляет состояние банка
func (сам *Банк) UpdateLst() {
	сам.сеть.Обновить()
}

// запускает банк в опрос
func (сам *Банк) пуск() {
	log.Printf("Банк.пуск()\n")
	fnRun := func() {
		defer time.Sleep(time.Minute * 5)
		сам.забрать()
		if сам.построитьУлучшить() {
			time.Sleep(time.Minute * 25)
			return
		}
		if сам.проверитьУскорить() {
			time.Sleep(time.Minute * 25)
			return
		}
		сам.сеть.Обновить()

		if ош := сам.получитьВсеРежимы(); ош != nil {
			log.Printf("ERRO Банк.пуск(): при получении списка режимов банка, err=\n\t%v\n", ош)
		}
		_, ош := сам.сделатьСеребро()
		if ош != nil {
			log.Printf("ERRO Банк.пуск(): при пуске производства банка, err=\n\t%v\n", ош)
		}
	}
	for {
		// <-сам.ВремяОпрос().КаналСиг()
		fnRun()
	}
}

// Проверка на ускорение строительства
func (сам *Банк) проверитьУскорить() bool {
	var (
		стрСсылка   = ""
		еслиНайдено = false
	)
	списБанк := сам.сеть.ВебВоркер().Получ("https://wartank.ru/buildings")
	// <td style="width:50%;padding-left:1px;"><a class="simple-but border" href="buildings?1-1.ILinkListener-buildings-1-building-rootBlock-actionPanel-freeBoostLink"><span><span>Ускорение</span></span></a>
	for _, стрСсылка = range списБанк {
		if strings.Contains(стрСсылка, `.ILinkListener-buildings-1-building-rootBlock-actionPanel-freeBoostLink`) {
			еслиНайдено = true
			break
		}
	}
	if !еслиНайдено {
		return false
	}
	_ссылка := strings.TrimPrefix(стрСсылка, `<td style="width:50%;padding-left:1px;"><a class="simple-but border" href="`)
	_ссылка = strings.TrimSuffix(_ссылка, `"><span><span>Ускорение</span></span></a>`)
	ссылка := "https://wartank.ru/" + _ссылка
	_= сам.сеть.ВебВоркер().Получ(ссылка)
	return true
}

// Забирает серебро
func (сам *Банк) забрать() {
	var (
		strOut      string
		еслиНайдено bool
	)
	списБанк := сам.сеть.ВебВоркер().Получ("https://wartank.ru/buildings")
	// <a class="simple-but border" href="buildings?0-1.ILinkListener-buildings-1-building-rootBlock-actionPanel-takeProductionLink"><span><span>Забрать</span></span></a>
	for _, strOut = range списБанк {
		if strings.Contains(strOut, `.ILinkListener-buildings-1-building-rootBlock-actionPanel-takeProductionLink`) {
			еслиНайдено = true
			break
		}
	}
	if !еслиНайдено {
		return
	}
	_ссылка := strings.TrimPrefix(strOut, `<a class="simple-but border" href="`)
	_ссылка = strings.TrimSuffix(_ссылка, `"><span><span>Забрать</span></span></a>`)
	// https://wartank.ru/buildings?3-1.ILinkListener-buildings-1-building-rootBlock-actionPanel-takeProductionLink
	ссылка := "https://wartank.ru/" + _ссылка
	_ = сам.сеть.ВебВоркер().Получ(ссылка)
}

// Проверяет необходимость постройки полигона
func (сам *Банк) построитьУлучшить() bool {
	var 		списБанк []string
	
	{ // Зайти на страницу постройки
		// https://wartank.ru/building-upgrade/Bank
		списБанк = сам.сеть.ВебВоркер().Получ("https://wartank.ru/building-upgrade/Bank")
		стрСсылка := ""
		еслиНайти := false
		// <a class="simple-but border mb5" href="Bank?192-1.ILinkListener-upgradeLink-link">
		for _, стрСсылка = range списБанк {
			if strings.Contains(стрСсылка, `href="Bank?`) {
				еслиНайти = true
				break
			}
		}
		if !еслиНайти { // Время полигона вышло
			return false
		}
		_ссылка := strings.TrimPrefix(стрСсылка, `<a class="simple-but border mb5" href="`)
		_ссылка = strings.TrimSuffix(_ссылка, `">`)
		ссылка := "https://wartank.ru/building-upgrade/" + _ссылка
		// https://wartank.ru/building-upgrade/Bank?162-1.ILinkListener-upgradeLink-link
		списБанк = сам.сеть.ВебВоркер().Получ(ссылка)
	}
	{ // Заказать постройку
		// https://wartank.ru/building-upgrade/Bank
		стрСсылка := ""
		еслиНайти := false
		// <a class="simple-but border mb5" href="Bank?163-1.ILinkListener-upgradeLink-link">
		for _, стрСсылка = range списБанк {
			if strings.Contains(стрСсылка, `href="Bank?`) {
				еслиНайти = true
				break
			}
		}
		if еслиНайти { // Время полигона вышло
			_ссылка := strings.TrimPrefix(стрСсылка, `<a class="simple-but border mb5" href="`)
			_ссылка = strings.TrimSuffix(_ссылка, `">`)
			ссылка := "https://wartank.ru/building-upgrade/" + _ссылка
			// https://wartank.ru/building-upgrade/Bank?162-1.ILinkListener-upgradeLink-link
			списБанк = сам.сеть.ВебВоркер().Получ(ссылка)
		}
	}
	{ // подтверждение постройки
		// <a class="simple-but border w50 mXa mb10" w:id="confirmLink" href="../wicket/page?187-1.ILinkListener-confirmLink"><span><span>да, подтверждаю</span></span></a>
		стрСсылка := ""
		еслиНайти := false
		for _, стрСсылка = range списБанк {
			if strings.Contains(стрСсылка, `.ILinkListener-confirmLink`) {
				еслиНайти = true
				break
			}
		}
		if !еслиНайти { // Время полигона вышло
			return false
		}
		_ссылка := strings.TrimPrefix(стрСсылка, `<a class="simple-but border w50 mXa mb10" w:id="confirmLink" href="../`)
		_ссылка = strings.TrimSuffix(_ссылка, "\"><span><span>да, подтверждаю</span></span></a>")
		ссылка := "https://wartank.ru/" + _ссылка
		// https://wartank.ru/wicket/page?135-1.ILinkListener-confirmLink
		_ = сам.сеть.ВебВоркер().Получ(ссылка)
	}
	log.Printf("Банк.построитьПровер(): построен успешно\n")
	return true
}

// РежимРаботы2 -- возвращает объект режима2
func (сам *Банк) РежимРаботы2() types.ИБанкРежим {
	return сам.режим2
}

// РежимРаботы1 -- возвращает объект режима1
func (сам *Банк) РежимРаботы1() types.ИБанкРежим {
	return сам.режим1
}

// СереброБот -- возвращает серебро от бота
func (сам *Банк) СереброБот() types.ИСтатПарам {
	return сам.сереброБот
}

// Запускает в производство серебро
func (сам *Банк) сделатьСеребро() (alias.МилСек, error) {
	var (
		lstBank     = сам.СписПолучить()
		ind         int
		strOut      string
		strLink     string
		еслиНайдено bool
	)
	time1 := сам.РежимРаботы1().ВремяСделать()
	time2 := сам.РежимРаботы2().ВремяСделать()
	if time1 > time2 {
		time1 = time2
	}
	for ind, strOut = range lstBank {
		if strings.Contains(strOut, time1) {
			ind += 7
			strLink = lstBank[ind]
			еслиНайдено = true
			break
		}
	}
	if еслиНайдено && strings.Contains(strLink, `>Начать производство</span>`) {
		lstLink := strings.Split(strLink, `<a class="simple-but border" href="`)
		strLink = lstLink[1]
		lstLink = strings.Split(strLink, `"><span><span>Начать производство</span></span></a>`)
		strLink = "https://wartank.ru/production/" + lstLink[0]
		lstBank, err := сам.сеть.Get(strLink)
		if err != nil {
			return 0, fmt.Errorf("BankNet.makeProduct(): при выполнении GET-запроса начать производство, err=%w", err)
		}
		for _, strOut := range lstBank {
			if strings.Contains(strOut, `<title>База</title>`) { // Это база, а не банк
				return 30, nil
			}
		}
		if err = сам.СтрОбновить(lstBank); err != nil {
			return 0, fmt.Errorf("BankNet.makeProduct(): при обновлении lstBank, err=%w", err)
		}
		if err := сам.ОбратВремяУст(alias.Время(time1)); err != nil {
			log.Printf("WARN Банк.makeProduct(): при установке времени производства банка(%v)\n\terr=%v\n", time1, err)
		}
	}
	return сам.ВремяОстат().ПолучМилСек(), nil
}

// Получает все режимы банка
func (сам *Банк) получитьВсеРежимы() error {
	var (
		lstBank  = сам.СписПолучить()
		ind      int
		strMode  string
		strMode1 string
		strMode2 string
	)
	{ // Получить первый режим
		for ind, strMode = range lstBank {
			if strings.Contains(strMode, `Кол-во: <span class="green2">`) {
				strMode1 = strMode
				break
			}
		}
		lstMode := strings.Split(strMode1, `Кол-во: <span class="green2">`)
		strMode1 = lstMode[1]
		lstMode = strings.Split(strMode1, `</span><br/>`)
		strMode1 = lstMode[0]
		iNum1, err := strconv.Atoi(strMode1)
		if err != nil {
			return fmt.Errorf("BankNet.getAllMode(): numSilver1(%v) not number, err=\n\t%w", strMode1, err)
		}
		сам.РежимРаботы1().Серебро().Уст(iNum1)
		// Установить время производства
		strTime1 := lstBank[ind+2]
		сам.РежимРаботы1().ВремяСделатьУст(strTime1)
		if iNum1 <= 2 { // Если банк слишком слабый
			return nil
		}
	}
	{ // Получить второй режим
		for _ind := ind + 2; _ind < len(lstBank); _ind++ {
			strMode := lstBank[_ind]
			if strings.Contains(strMode, `Кол-во: <span class="green2">`) {
				strMode2 = strMode
				ind = _ind
				break
			}
		}
		lstMode := strings.Split(strMode2, `Кол-во: <span class="green2">`)
		strMode2 = lstMode[1]
		lstMode = strings.Split(strMode2, `</span><br/>`)
		strMode2 = lstMode[0]
		iNum2, err := strconv.Atoi(strMode2)
		if err != nil {
			return fmt.Errorf("BankNet.getAllMode(): numSilver2(%v) not number, err=\n\t%w", strMode2, err)
		}
		сам.РежимРаботы2().Серебро().Уст(iNum2)
		// Установить время производства
		strTime2 := lstBank[ind+2]
		сам.РежимРаботы2().ВремяСделатьУст(strTime2)
	}
	return nil
}
